﻿init python:
    from copy import copy
    import random
    import pygame
    import time
    random.seed(time.perf_counter_ns())
    class magnet:
        def __init__(self, letter):
            self.letter = letter
            self.x = 0
            self.y = 0
            self.rotation = 0
            self.hue = 120

    class magnet_manager:
        def __init__(self):
            self.magnets = [
                "a", "b", "c", "d", "e", "f", "g", "h", "i", "j",
                "k", "l", "m", "n", "o", "p", "q", "r", "s", "t",
                "u", "v", "w", "x", "y", "z",
                "1", "2", "3", "4", "5", "6", "7", "8", "9", "0",
            ]
            self.top = []
            self.bottom = []
            self.holding = None
            self.event_handler = event_handler()

        def take(self):
            renpy.play("fridge magnets/take.ogg", "sound")
            m = magnet(random.choice(self.magnets))
            m.rotation = random.randint(0,359)
            m.hue = random.randint(0,359)
            self.holding = m
        def put(self, place):
            if self.holding:
                renpy.play("fridge magnets/place.ogg", "sound")
                if place == "top":
                    self.top.append(self.holding)
                    self.holding = None
                elif place == "bottom":
                    self.bottom.append(self.holding)
                    self.holding = None
                else:
                    self.holding = None
            
        def tick(self):
            if self.holding:
                pos = renpy.get_mouse_pos()
                self.holding.x = pos[0]
                self.holding.y = pos[1]
                if self.event_handler.active:
                    self.holding.rotation += self.event_handler.active
                    if self.holding.rotation > 359:
                        self.holding.rotation = 0
        def swap(self, place, letter):
            if place == "top":
                self.top.remove(letter)
            else:
                self.bottom.remove(letter)
            self.put(place)
            self.holding = letter

    class event_handler(renpy.Displayable):
        def __init__(self):
            super(renpy.Displayable,self).__init__()
            self.active = 0
        def render(self,width,height,st,at):
            return renpy.Render(0, 0)
        def event(self, ev, x, y, st):
            if ev.type == pygame.KEYDOWN:
                if ev.key == pygame.K_d:
                    self.active = 2
                    raise renpy.IgnoreEvent()
                elif ev.key == pygame.K_a:
                    self.active = -2
                    raise renpy.IgnoreEvent()
            elif ev.type == pygame.KEYUP:
                if ev.key == pygame.K_d:
                    self.active = 0
                elif ev.key == pygame.K_a:
                    self.active = 0
            return None

screen fridge_magnets():
    modal True
    default g = magnet_manager()
    add g.event_handler
    button:
        xysize 800,560
        # background "#fff8"
        offset 300, 30
        action Function(g.put, "top")
    button:
        xysize 800,370
        # background "#fff8"
        offset 300, 680
        action Function(g.put, "bottom")
    button:
        offset 1300,780
        add "fridge_box"
        action Function(g.take)
    for i in g.top:
        fixed fit_first True:
            add im.MatrixColor(f"images/fridge/fridge_letters_{i.letter}.png",im.matrix.hue(i.hue)) yoffset 4 pos i.x,i.y anchor .5,.5 at rotate(i.rotation)
            button:
                padding 0,0 pos i.x,i.y anchor .5,.5
                add im.MatrixColor(f"images/fridge/fridge_letters_{i.letter}.png",im.matrix.hue(i.hue))
                at rotate(i.rotation)
                action Function(g.swap, "top", i)
    for i in g.bottom:
        fixed fit_first True:
            add im.MatrixColor(f"images/fridge/fridge_letters_{i.letter}.png",im.matrix.hue(i.hue)) yoffset 4 pos i.x,i.y anchor .5,.5 at rotate(i.rotation)
            button:
                padding 0,0 pos i.x,i.y anchor .5,.5
                add im.MatrixColor(f"images/fridge/fridge_letters_{i.letter}.png",im.matrix.hue(i.hue))
                at rotate(i.rotation)
                action Function(g.swap, "bottom", i)
    if g.holding:
        add im.MatrixColor(f"images/fridge/fridge_letters_{g.holding.letter}.png",im.matrix.hue(g.holding.hue)) at rotate(g.holding.rotation) pos g.holding.x,g.holding.y anchor .5,.5 yoffset 4
        add im.MatrixColor(f"images/fridge/fridge_letters_{g.holding.letter}.png",im.matrix.hue(g.holding.hue)) at rotate(g.holding.rotation) pos g.holding.x,g.holding.y anchor .5,.5
        timer .01 repeat True action Function(g.tick)

    button:
        align .5,1.0 padding 20,20 yoffset -20 background "#0009"
        text _("Done")
        action Return()

label fridge_magnets_example:
    show fridge_background with dissolve
    call screen fridge_magnets

